{"openapi":"3.0.0","info":{"title":"OVHcloud API specification","description":"Specification for OVHcloud API","version":"1.0","contact":{"name":"OVH","email":"api@ml.ovh.net"}},"servers":[{"url":"https://api.eu.ovhcloud.com/v2"}],"components":{"schemas":{"any":{"description":"Can be anything (text, int, bool, json, html, etc.)","example":"This is a content of any type !"},"duration":{"type":"string","description":"Duration (e.g., P1Y2M3DT4H6M9S)","example":"P1Y2M3DT4H6M9S"},"email":{"type":"string","description":"Email address (e.g., api@ml.ovh.net)","format":"email","example":"api@ml.ovh.net"},"internationalPhoneNumber":{"type":"string","description":"International phone number","format":"phone-number"},"ip":{"type":"string","description":"IP address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipBlock":{"type":"string","description":"IP (v4 or v6) CIDR notation (e.g., 192.0.2.0/24)","format":"ip-block","example":"192.0.2.0/24"},"ipInterface":{"type":"string","description":"IP address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipv4":{"type":"string","description":"IPv4 address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipv4Block":{"type":"string","description":"IPv4 CIDR notation (e.g., 192.0.2.0/24)","format":"ipv4-block","example":"192.0.2.0/24"},"ipv6":{"type":"string","description":"IPv6 address (e.g., 2001:41d0:1:1994::1)","format":"ipv6","example":"2001:41d0:1:1994::1"},"ipv6Block":{"type":"string","description":"IPv6 CIDR notation (e.g., 2001:41d0::/128)","format":"ipv6-block","example":"2001:41d0::/128"},"macAddress":{"type":"string","description":"MAC address (e.g., 00:00:5e:00:53:01)","format":"mac-address","example":"00:00:5e:00:53:01"},"phoneNumber":{"type":"string","description":"Phone number","format":"phone-number"},"publicCloud.reference.storage.object.BucketOptions":{"type":"object","description":"Allowed values for the object storage bucket creation options","properties":{"encryptionAlgorithms":{"type":"array","description":"Server-side encryption algorithms selectable at bucket creation","items":{"$ref":"#/components/schemas/publicCloud.storage.object.BucketEncryptionAlgorithmEnum"},"readOnly":true},"objectLockModes":{"type":"array","description":"Object lock retention modes selectable at bucket creation","items":{"$ref":"#/components/schemas/publicCloud.storage.object.BucketObjectLockModeEnum"},"readOnly":true},"userRoles":{"type":"array","description":"User roles assignable on a bucket, one of which is flagged as the default","items":{"$ref":"#/components/schemas/publicCloud.reference.storage.object.UserRole"},"readOnly":true},"versioningStatuses":{"type":"array","description":"Versioning statuses selectable at bucket creation","items":{"$ref":"#/components/schemas/publicCloud.storage.object.BucketVersioningStatusEnum"},"readOnly":true}}},"publicCloud.reference.storage.object.ObjectRestoreValidation":{"type":"object","description":"Bounds for the number of days an archived object stays restored","properties":{"defaultDays":{"type":"integer","description":"Number of days preselected when no duration is provided","readOnly":true},"maxDays":{"type":"integer","description":"Maximum number of days an object can be restored for","readOnly":true},"minDays":{"type":"integer","description":"Minimum number of days an object can be restored for","readOnly":true}}},"publicCloud.reference.storage.object.ObjectStorage":{"type":"object","description":"Global, non region-scoped object storage reference data: storage classes, allowed bucket option values and input validation constraints","properties":{"bucketOptions":{"allOf":[{"$ref":"#/components/schemas/publicCloud.reference.storage.object.BucketOptions"}],"description":"Allowed values for the bucket creation options","readOnly":true},"storageClasses":{"type":"array","description":"Object storage classes and their billing constraints","items":{"$ref":"#/components/schemas/publicCloud.reference.storage.object.StorageClass"},"readOnly":true},"validation":{"allOf":[{"$ref":"#/components/schemas/publicCloud.reference.storage.object.Validation"}],"description":"Input validation constraints applied to object storage resources","readOnly":true}}},"publicCloud.reference.storage.object.StorageClass":{"type":"object","description":"An object storage class and its billing constraints","properties":{"minBilledRetentionDays":{"type":"integer","description":"Minimum number of days an object is billed for in this storage class, even when deleted earlier. Null when the class has no minimum billed retention.","nullable":true,"readOnly":true},"name":{"allOf":[{"$ref":"#/components/schemas/publicCloud.storage.object.StorageClassEnum"}],"description":"Unique identifier of the storage class","readOnly":true}}},"publicCloud.reference.storage.object.UserRole":{"type":"object","description":"An S3™ user role assignable on a bucket","properties":{"isDefault":{"type":"boolean","description":"Whether this role is the one preselected when granting a user access to a bucket","readOnly":true},"name":{"allOf":[{"$ref":"#/components/schemas/publicCloud.reference.storage.object.UserRoleEnum"}],"description":"Unique identifier of the role","readOnly":true}}},"publicCloud.reference.storage.object.UserRoleEnum":{"type":"string","description":"S3™ user roles assignable on a bucket, as normalized by the API. `ADMIN`: Full control over the bucket, including its policy and configuration. `READ_WRITE`: Read and write objects in the bucket. `READ_ONLY`: Read objects in the bucket. `DENY`: No access to the bucket.","enum":["ADMIN","DENY","READ_ONLY","READ_WRITE"]},"publicCloud.reference.storage.object.Validation":{"type":"object","description":"Input validation constraints applied to object storage resources","properties":{"objectRestore":{"allOf":[{"$ref":"#/components/schemas/publicCloud.reference.storage.object.ObjectRestoreValidation"}],"description":"Bounds for the duration an archived object is restored for","readOnly":true}}},"publicCloud.storage.object.BucketEncryptionAlgorithmEnum":{"type":"string","description":"Supported encryption algorithms for S3™ compatible buckets","enum":["AES256","PLAINTEXT"]},"publicCloud.storage.object.BucketObjectLockModeEnum":{"type":"string","description":"Object lock retention modes","enum":["COMPLIANCE","GOVERNANCE"]},"publicCloud.storage.object.BucketVersioningStatusEnum":{"type":"string","description":"Versioning status for an S3™ compatible bucket","enum":["DISABLED","ENABLED","SUSPENDED"]},"publicCloud.storage.object.StorageClassEnum":{"type":"string","description":"Available S3™ storage classes","enum":["DEEP_ARCHIVE","GLACIER_IR","HIGH_PERF","STANDARD","STANDARD_IA"]},"time":{"type":"string","description":"Time (e.g., 15:04:05)","format":"time","example":"15:04:05"}},"securitySchemes":{"oAuth2AuthCode":{"type":"oauth2","description":"Oauth2","x-client-id":"1bb9c7df371741c0","x-client-secret":"a5b4de870aca620d10fbf63cd18d205b","flows":{"authorizationCode":{"authorizationUrl":"https://auth.eu.ovhcloud.com/oauth2/authorize","tokenUrl":"https://auth.eu.ovhcloud.com/oauth2/token","scopes":{"account/all":"Manage your account","all":"Manage your whole account and all your services","services/all":"Manage your services lifecycle and billing"}}}}}},"paths":{"/publicCloud/project/{projectId}/reference/storage/object":{"get":{"operationId":"getObjectStorageReference","summary":"Get object storage reference data","description":"Returns the storage classes with their minimum billed retention, the values accepted at bucket creation, and the allowed durations for restoring an archived object. Region capabilities, such as replication support, are returned by each region in `/reference/region`.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"projectId","description":"Project ID","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/publicCloud.reference.storage.object.ObjectStorage"}}}}},"tags":["Reference"],"x-developer-hub-navigation":[["Public Cloud","Storage","Object Storage","Service references"],["Public Cloud","Project Management","Service references","Storage"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/v2/publicCloud/project/{projectId}/reference/storage/object\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/v2/publicCloud/project/{projectId}/reference/storage/object\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"publicCloudProject:apiovh:reference/storage/object/get","required":true}]}}},"tags":[{"name":"Reference","x-tag-expanded":false,"description":"Missing description"}]}
